
#include "stdafx.h"
#include "JakTool.h"

#define sizeof_JakHeader 43
struct JakHeader
{
	char Magic[18];		// This_Is_Jack_File\0
	char dummy1[2];
	DWORD No;			// ؂􂫃t@C̘A( 1` )
	DWORD FileNameLen;	// t@C̒
	DWORD FileSize;		// ؂􂭑Õt@CTCY
	FILETIME FileTime;	// t@C̍XVt
	char dummy2[3];
//	char* OrigFileName;	// t@C ( NULL I[Ȃ )
};

int CJakTool::FindHeader( const BYTE* hdr,DWORD size )
{
	static const char Magic[]="This_Is_Jack_File";

	if( size<sizeof_JakHeader )
		return -1;

	if( 0==strcmp((char*)hdr,Magic) )
	{
		if( sizeof_JakHeader+((JakHeader*)hdr)->FileNameLen<size )
			return 0;
	}
	else if( hdr[0]=='M' && hdr[1]=='Z' )
	{
		DWORD prev = 0xffffffff;
		for( DWORD i=0; i<size-sizeof_JakHeader; i++ )
		{
			if( hdr[i]!='T' )continue;
			if( hdr[i+1]!='h' )continue;
			if( hdr[(++i)+1]!='i' )continue;
			if( hdr[(++i)+1]!='s' )continue;
			if( hdr[(++i)+1]!='_' )continue;
			if( 0!=strcmp((char*)hdr+(++i)+1,Magic+5) )continue;

			// X^u̕Ɉ邱Ƃ̂ŁA
			// "This_Is_..."Ƃ͈Skip
			if( prev==0xffffffff )
				prev = (i-4);
			else
				return (i-4);
		}
		if( prev!=0xffffffff )
			return prev;
	}
	return -1;
}

bool CJakTool::Check(  const char* fname, unsigned long fsize )
{
	const unsigned char* hdr = CTool::common_buf;
	unsigned long siz = (fsize>XACR_BUFSIZE ? XACR_BUFSIZE : fsize);
//--------------------------------------------------------------------//

	return (-1!=FindHeader( hdr, siz>32768 ? 32768 : siz ));
}

bool CJakTool::Extract( const char* fname, const char* ddir )
{
	unsigned char* buf = CTool::common_buf;
//--------------------------------------------------------------------//

	int y,d;
	kiutil::pathSplit( fname,&y,&d );
	char basedir[MAX_PATH+1]={'\0'};
	char bodyname[MAX_PATH+1];
	char outname[MAX_PATH+1];
	if( y!=-1 )
		strncpy( basedir,fname,y+1 );
	strcpy( bodyname,fname+y+1 );

// Ƃ肠At@CɗČo[W

	// wb_To
	FILE* jak = fopen( fname,"rb" );
	if( !jak )
		return false;
	int hpos = FindHeader( buf,fread( buf,1,32768,jak ) );
	fclose( jak );
	if( hpos==-1 )
		return false;
	JakHeader* pHead = (JakHeader*)(buf+hpos);

	// wb_ǂ݂Ƃ
	int fnln = 
		MAX_PATH > pHead->FileNameLen ? pHead->FileNameLen : MAX_PATH;
	memcpy( outname, buf+hpos+sizeof_JakHeader, fnln );
	outname[ fnln ] = '\0';
	FILETIME updttime = pHead->FileTime;

	// Jackt@Cԍȍ~ۑĂ
	char tmp[18];
	sprintf( tmp, "%d.%s", pHead->No, kiutil::pathExt(fname) );
	char* p;
	for( p=bodyname; *p!=0; p=CharNext(p) )
		if( 0==strcmpi(p,tmp) )
			break;
	*p='\0';

	// JnI
	FILE* out = fopen( kiutil::pathMake(outname),"wb" );
	if( !out )
		return false;

	for( int i=1; i!=(1<<31); i++ )
	{
		// i Ԗڂ̃t@C
		char jackfile[MAX_PATH*2];
		strcpy( jackfile,basedir );
		strcat( jackfile,bodyname );
		sprintf( tmp,"%d.jak",i );
		strcat( jackfile,tmp );

		// i Ԗڂ̃t@CJ
		jak = fopen( jackfile,"rb" );
		if( !jak )
		{
			strcpy( jackfile,basedir );
			strcat( jackfile,bodyname );
			sprintf( tmp,"%d.exe",i );
			strcat( jackfile,tmp );
			if( !(jak=fopen( jackfile,"rb" )) )
				break;
		}
		hpos = FindHeader( buf,fread( buf,1,32768,jak ) );
		if( hpos==-1 )
		{
			fclose( jak );
			break;
		}

		// t@Cƃwb_Ƃ̐mF
		pHead = (JakHeader*)(buf+hpos);
		if( pHead->No!=(DWORD)i )
		{
			fclose( jak );
			break;
		}
		char str[MAX_PATH];
		fnln = 
			MAX_PATH > pHead->FileNameLen ? pHead->FileNameLen : MAX_PATH;
		memcpy( str, buf+hpos+sizeof_JakHeader, fnln );
		str[ fnln ] = '\0';
		if( 0!=stricmp( outname,str ) )
		{
			fclose( jak );
			break;
		}

		// o
		int len;
		fseek( jak,hpos+sizeof_JakHeader+pHead->FileNameLen,SEEK_SET );
		while( -1!=(len=fread( buf,1,XACR_BUFSIZE,jak )) && 0!=len )
			fwrite( buf,1,len,out );

		fclose( jak );
	}

	fclose( out );
	kiutil::timeSet( outname, &updttime );
	return true;
}
